% *** load data
  data_simu
  n = size(D,1); T = 8;
% *** matrix of covariates:
%   1- 8: first covariate at each observation
%   9-16: second covariate at each observation
%  17-25: first response variable at each observation
%  26-34: first response variable at each observation
% *** organize response matrix ***
  Y1 = D(:,18:25);
  Y2 = D(:,27:34);
  Y = zeros(4,n,T);
  for i = 1:n;
    for t = 1:T;
      ind = 1+2*Y1(i,t)+Y2(i,t);
      Y(ind,i,t) = 1;
    end
  end
  Y0 = [D(:,17) D(:,26)];
% *** design matrices X and Y0
  r=2;
  lev=[2 2];
  type=['l' 'l'];
  nt = prod(lev); np = sum(lev)-r; ni = 1;
  lbe = 4*2;
  X = zeros(np+ni,lbe+ni,n,T);
  I1 = [];
  for j = 1:r,
    I1 = blkdiag(I1,ones(lev(j)-1,1));
  end
  I2 = eye(ni);
  for i=1:n,
    for t=1:T,
      if t==1,
        y0=Y0(i,:);
      else
        y0=[Y1(i,t-1) Y2(i,t-1)];
      end
      Xit = blkdiag([kron(I1,[D(i,t) D(i,8+t)]) kron(I1,y0)],I2);
      X(:,:,i,t) = Xit;
    end
  end
% *** fit model with 1 latent state
  [Al1,par1,phi1,PI1,we1,lk1,aic1,bic1,La1,Pio1,seAl1,separ1] = est_marg_long_lm(Y,X,Y0,lev,type,1);
  mal1 = Al1; be1 = par1(1:4); ga1 = par1(5:8); de1 = par1(9);
  sebe1 = separ1(1:4); sega1 = separ1(5:8); sede1 = separ1(9);
% *** fit model with 2 latent states
  [Al2,par2,phi2,PI2,we2,lk2,aic2,bic2,La2,Pio2,seAl2,separ2] = est_marg_long_lm(Y,X,Y0,lev,type,2);  
  mal2 = Al2*we2; be2 = par2(1:4); ga2 = par2(5:8); de2 = par2(9);
  sebe2 = separ2(1:4); sega2 = separ2(5:8); sede2 = separ2(9);  
% *** fit model with 3 latent states ***
  [Al3,par3,phi3,PI3,we3,lk3,aic3,bic3,La3,Pio3,seAl3,separ3,sephi3,setau3,J3] = est_marg_long_lm(Y,X,Y0,lev,type,3);
  mal3 = Al3*we3; be3 = par3(1:4); ga3 = par3(5:8); de3 = par3(9);
  sebe3 = separ3(1:4); sega3 = separ3(5:8); sede3 = separ3(9);
[Al4,par4,phi4,PI4,we4,lk4,aic4,bic4,La4,Pio4,seAl4,separ4,sephi4,setau4,J4] = est_marg_long_lm(Y,X,Y0,lev,type,4);
  mal4 = Al4*we4; be4 = par4(1:4); ga4 = par4(5:8); de4 = par4(9);
  sebe4 = separ4(1:4); sega4 = separ4(5:8); sede4 = separ4(9);
  [Al5,par5,phi5,PI5,we5,lk5,aic5,bic5,La5,Pio5,seAl5,separ5,sephi5,setau5,J5] = est_marg_long_lm(Y,X,Y0,lev,type,5);
  mal5 = Al5*we5; be5 = par5(1:4); ga5 = par5(5:8); de5 = par5(9);
  sebe5 = separ5(1:4); sega5 = separ5(5:8); sede5 = separ5(9);
% *** Viterbi path (contained in Pred for each subject) ***
  Pio2p = permute(Pio2,[2 3 1]);
  Pred = zeros(n,T);
  for i = 1:n,
    Pred(i,:) = viterbi_path(La2(i,:)',PI2,Pio2p(:,:,i));
  end
